%define name tt-rss
%define version 1.5.1
%define release 2
%define httpuser apache

%if %{?fedora}%{?rhel} >= 5
%global useselinux 1
%else
%global useselinux 0
%endif

Summary: Web based RSS reader
Name: %{name}
Version: %{version}
Release: %{release}%{?dist}
Distribution: RHEL
License: GNU GPL
URL: http://tt-rss.org/redmine/wiki/tt-rss/
Group: application/internet
Source: %{name}-%{version}.tar.gz
Source1: httpd.conf
Source2: cron
Source3: logrotate.conf

Patch0: tt-rss-1.5.0-allow_admin_http_auth.patch
Patch1: tt-rss-1.5.0-auto_create.patch
Patch2: tt-rss-1.5.1-allow_open_basedir.patch

Packager: Daniel B. <daniel@firewall-services.com>
BuildArch: noarch
BuildRoot: /var/tmp/%{name}-%{version}

Requires: php-gd
Requires: httpd
Requires: logrotate

%description
http://tt-rss.org/redmine/wiki/tt-rss/
Tiny Tiny RSS is an open source web-based news feed (RSS/Atom)
aggregator, designed to allow you to read news from any location,
while feeling as close to a real desktop application as possible.

%prep
%setup

%patch0 -p1
%patch1 -p1
%patch2 -p1

%build
# empty build

%install

%{__rm} -rf %{buildroot}
%{__mkdir} -p %{buildroot}/%{_datadir}/%{name}
for a in $(find ./ -mindepth 1 -maxdepth 1 -type d \! -name schema -print); do
    cp -r $a %{buildroot}/%{_datadir}/%{name}/
done
cp {*.php,*.css,*.js,*.xsl} %{buildroot}/%{_datadir}/%{name}/

# rename icons to rssicons so it won't clash with the global icons directory
%{__mv} %{buildroot}/%{_datadir}/%{name}/icons %{buildroot}/%{_datadir}/%{name}/rssicons

# remove cache and lock directories
%{__rm} -Rf %{buildroot}/%{_datadir}/%{name}/{cache,lock}

# And create them at the correct place
%{__mkdir} -p %{buildroot}/%{_localstatedir}/cache/%{name}/{magpie,simplepie}
%{__mkdir} -p %{buildroot}/%{_localstatedir}/lock/%{name}

sed -e "s|\"pgsql\"|\"mysql\"|g" \
    -e "s|cache/magpie|%{_localstatedir}/cache/%{name}/magpie|g" \
    -e "s|cache/simplepie|%{_localstatedir}/cache/%{name}/simplepie|g" \
    -e "s|\"icons\"|\"rssicons\"|g" \
    -e "s|'lock'|'%{_localstatedir}/lock/%{name}'|g" \
    config.php-dist \
    > %{buildroot}/%{_datadir}/%{name}/config.php

%{__mkdir} -p %{buildroot}/%{_sysconfdir}/httpd/conf.d/
%{__install} -m 0644 %{SOURCE1} %{buildroot}/%{_sysconfdir}/httpd/conf.d/%{name}.conf
sed -i -e "s|__ROOT_DIR__|%{_datadir}/%{name}|g" \
       -e "s|__CACHE_DIR__|%{_localstatedir}/cache/%{name}|g" \
       -e "s|__LOCK_DIR__|%{_localstatedir}/lock/%{name}|g" \
       %{buildroot}/%{_sysconfdir}/httpd/conf.d/%{name}.conf

%{__mkdir} -p %{buildroot}/%{_localstatedir}/log/
touch %{buildroot}/%{_localstatedir}/log/%{name}.log

%{__mkdir} -p %{buildroot}/%{_sysconfdir}/cron.d
%{__install} -m 0644 %{SOURCE2} %{buildroot}/%{_sysconfdir}/cron.d/%{name}
sed -i -e "s|__APACHE__|%{httpuser}|g" \
       -e "s|__ROOT_DIR__|%{_datadir}/%{name}|g" \
       -e "s|__LOG_FILE__|%{_localstatedir}/log/%{name}.log|g" \
       %{buildroot}/%{_sysconfdir}/cron.d/%{name}

%{__mkdir} -p %{buildroot}/%{_sysconfdir}/logrotate.d/
%{__install} -m 644 %{SOURCE3} %{buildroot}/%{_sysconfdir}/logrotate.d/%{name}
sed -i -e "s|__LOG_DIR__|%{_localstatedir}/log/%{name}.log|g" \
       -e "s|__APACHE__|%{httpuser}|g" \
       %{SOURCE3} %{buildroot}/%{_sysconfdir}/logrotate.d/%{name}

%clean
rm -rf %{buildroot}

%post
%if %{useselinux}
(
# New File context
semanage fcontext -a -s system_u -t httpd_log_t -r s0 "%{_localstatedir}/log/%{name}.log"
semanage fcontext -a -s system_u -t httpd_var_lib_t -r s0 "%{_localstatedir}/lock/%{name}(/.*)?"
semanage fcontext -a -s system_u -t httpd_var_lib_t -r s0 "%{_datadir}/%{name}/rssicons(/.*)?"
semanage fcontext -a -s system_u -t httpd_var_lib_t -r s0 "%{_localstatedir}/cache/%{name}(/.*)?"
semanage fcontext -a -s system_u -t httpd_var_lib_t -r s0 "%{_datadir}/%{name}/lib/htmlpurifier/library/HTMLPurifier/DefinitionCache(/.*)?"
# files created by app
restorecon -R %{_datadir}/%{name}/
restorecon -R %{_localstatedir}/cache/%{name}
restorecon -R %{_localstatedir}/log/%{name}.log
restorecon -R %{_localstatedir}/lock/%{name}
) &>/dev/null
%endif
/sbin/service httpd condrestart > /dev/null 2>&1 || :


%postun
%if %{useselinux}
if [ "$1" -eq "0" ]; then
    # Remove the File Context
    (
    semanage fcontext -d "%{_localstatedir}/log/%{name}.log"
    semanage fcontext -d "%{_localstatedir}/cache/%{name}(/.*)?"
    semanage fcontext -d "%{_datadir}/%{name}/rssicons(/.*)?"
    semanage fcontext -d "%{_localstatedir}/lock/%{name}(/.*)?"
    semanage fcontext -d "%{_datadir}/%{name}/lib/htmlpurifier/library/HTMLPurifier/DefinitionCache(/.*)?"
    ) &>/dev/null
fi
%endif
/sbin/service httpd condrestart > /dev/null 2>&1 || :


%files
%defattr(-,root,root)
%doc README LICENSE schema
%{_datadir}/%{name}
%dir %attr(770,root,%{httpuser}) %{_localstatedir}/cache/%{name}/magpie
%dir %attr(770,root,%{httpuser}) %{_localstatedir}/cache/%{name}/simplepie
%dir %attr(775,root,%{httpuser}) %{_localstatedir}/lock/%{name}/
%dir %attr(775,root,%{httpuser}) %{_datadir}/%{name}/rssicons
%dir %attr(775,root,%{httpuser}) %{_datadir}/%{name}/lib/htmlpurifier/library/HTMLPurifier/DefinitionCache/Serializer
%dir %attr(775,root,%{httpuser}) %{_datadir}/%{name}/lib/htmlpurifier/library/HTMLPurifier/DefinitionCache
%attr(660,root,%{httpuser}) %{_localstatedir}/log/%{name}.log
%config(noreplace) %attr(660,root,%{httpuser}) %{_datadir}/%{name}/config.php
%config(noreplace) %{_sysconfdir}/httpd/conf.d/%{name}.conf
%config(noreplace) %{_sysconfdir}/cron.d/%{name}
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}


%changelog
* Wed Jan 26 2011 Daniel B. <daniel@firewall-services.com> 1.5.1-2
- Allow open_basedir restriction

* Wed Jan 26 2011 Daniel B. <daniel@firewall-services.com> 1.5.1-1
- upstream upgrade to 1.5.1

* Mon Jan 03 2011 Daniel B. <daniel@firewall-services.com> 1.5.0-0
- initial release
- include patches for a better integration with LemonLDP::NG

